package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */



import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class AlignMarks extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener{
	ShowPicJPanel picJPanel;
	int nomwidth=135, nomheight=115;
	
    public AlignMarks(ShowPicJPanel picJPanel) {   
    super("Align");
    getContentPane().setLayout(new BorderLayout()); 
	WidgetMaker wmk = new WidgetMaker(this);
	int rr=135, gg=255,  bb=150;
	this.picJPanel = picJPanel;
    setSize(nomwidth, nomheight);
	JPanel alignPan;
	
	alignPan = new JPanel();
	alignPan.setLayout(new GridLayout(0,1));
	alignPan.add(wmk.makeAJLabel("align",new Color(0,120,120)));
	alignPan.add(wmk.makeAJButton("mark 0",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 1",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 2",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 3",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 4",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 5",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 6",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 7",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 8",rr,gg,bb));
	rr += 10;  gg -= 10;  bb -= 5;
	alignPan.add(wmk.makeAJButton("mark 9",rr,gg,bb));
	alignPan.add(wmk.makeAJButton("all marks"));
	alignPan.add(wmk.makeAJButton("unalign"));
	getContentPane().add("Center",alignPan);	
	addWindowListener(this);
  }		

// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	 

// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
	    	if(arg.equals("mark 0")) {
				picJPanel.alignMarker(10);
    			}
	    	if(arg.equals("mark 1")) {
				picJPanel.alignMarker(1);
    			}
	    	if(arg.equals("mark 2")) {
				picJPanel.alignMarker(2);
    			}
	    	if(arg.equals("mark 3")) {
				picJPanel.alignMarker(3);
    			}
	    	if(arg.equals("mark 4")) {
				picJPanel.alignMarker(4);
    			}
	    	if(arg.equals("mark 5")) {
				picJPanel.alignMarker(5);
    			}
	    	if(arg.equals("mark 6")) {
				picJPanel.alignMarker(6);
    			}
	    	if(arg.equals("mark 7")) {
				picJPanel.alignMarker(7);
    			}
	    	if(arg.equals("mark 8")) {
				picJPanel.alignMarker(8);
    			}
	    	if(arg.equals("mark 9")) {
				picJPanel.alignMarker(9);
    			}
	    	if(arg.equals("all marks")) {
				picJPanel.alignAllMarkers();
    			}
	    	if(arg.equals("unalign")) {
				picJPanel.unalign();
    			}
    }

	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

