package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;


class Centrosomes extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel;
	int nomwidth=175, nomheight=238;
	final static int PICK_NEAREST_CENT = 70;
	final static int MOVE_SELECTED_CENT = 71;
	final static int ADD_NEW_CENT = 72;
	boolean actOnIncomingMouseLocs = false;
	int [] zero = {0, 0, 0};
	CrossMark rootCross = null;
	CrossMark selectedCross = null;
	
    public Centrosomes(ShowPicJPanel picJPanel) {   
	super("Centrosome Locator");
	this.picJPanel = picJPanel;
	int rr=100,gg=200,bb=255;
	WidgetMaker wmk = new WidgetMaker(this);
	// initiate the linked list of centrosomes
	rootCross = new CrossMark(this);
	selectedCross= rootCross;
	getContentPane().setLayout(new GridLayout(0, 1)); 
    setSize(nomwidth, nomheight);

	getContentPane().add(wmk.makeAJButton("add new centrosome at next click",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("shrink selected centrosome",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("enlarge selected centrosome",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("GoTo selected centrosome",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("select next centrosome",rr,gg,bb));
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("select previous centrosome",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("Select first centrosome",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("next click picks nearest cent",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("next click moves selected cent",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("show all centrosomes",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("hide all centrosomes",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("print shifts/centrosome data file",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("redraw",rr,gg,bb)); 
	rr +=10;  gg-=5; bb -=10;	
	getContentPane().add(wmk.makeAJButton("DELETE SELECTED CENTROSOME",rr,gg,bb)); 
	addWindowListener(this);
	}

// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	 
   
   public void writeCentrosomeListToDisk(ArchiveMarks disker){
	String stg;
        CrossMark cm;
	int radius;
	int [] xyz={0, 0, 0};
/* sample of what it's supposed to look like
@sphere 1 256 303 146  8    These taken from .rgb files (not 
@sphere 1 262 316 146 8   .tiff files, so the y-components
@sphere 1 492 215 136 8   are correct. No need to invert.
@sphere 1 495 217 144 8
@sphere 1 46 477 146 8
@sphere 1 52 484 148 8
@sphere 1 626 21 124 8
@sphere 1 633 32 124 8  */
	cm=rootCross;
	while(!cm.isLast()) { // there are some centrosomes to write out...
	    cm = cm.next;
	    xyz = cm.tellAbsLocation();
	    xyz[1] = 511-xyz[1]; // invert the y-coordinate
	    radius = cm.tellRadius();
	    stg = ("@sphere 1 "+xyz[0]+" "+xyz[1]+" "+xyz[2]+" "+radius);
	    disker.writeAString(stg);
	    }
    }

   public void archiveCents(ArchiveMarks disker, boolean ifWrite) {
        CrossMark cm;
	int icent=0, radius;
	int [] xyz={0, 0, 0};
	double badval = 77777.7;
        if(ifWrite) {
	   cm=rootCross;
	   while(!cm.isLast()) { // there are some centrosomes to write out...
		cm = cm.next;
		++icent;
		xyz = cm.tellAbsLocation();
		radius = cm.tellRadius();
		disker.writeNum((double)radius, (" = radius of centrosome "+icent));
		disker.writeNum((double)xyz[0], (" = x-coord of centrosome "+icent));
		disker.writeNum((double)xyz[1], (" = y-coord of centrosome "+icent));
		disker.writeNum((double)xyz[2], (" = z-coord of centrosome "+icent));
		}
	    }
	else {
	    talk("eliminating current centrosomes...");
	    deleteAllCentrosomes();
	    
	    icent=0;
	    boolean ifgood = true;
	    cm = rootCross;
	    ifgood=true;
	    while(ifgood) {
		radius = (int)(disker.getNextFileDouble(badval));
		if(radius == (int)badval  || radius==(-7777)) ifgood=false;
		talk("got radius == "+radius);
		if(ifgood) {
		    xyz[0] = (int)(disker.getNextFileDouble(badval));
		    if(xyz[0] == (int)badval) ifgood=false;
		    }
		if(ifgood) {
		    xyz[1] = (int)(disker.getNextFileDouble(badval));
		    if(xyz[1] == (int)badval) ifgood=false;
		    }
		if(ifgood) {
		    xyz[2] = (int)(disker.getNextFileDouble(badval));
		    if(xyz[2] == (int)badval) ifgood=false;
		    }
		if(ifgood) { // OK we read in a valid new centrosome
		    selectedCross = cm.insertNewCrossMark(xyz, radius, this);
		    cm=selectedCross;
		    cm.appear();
		    cm.tellStats();		     
		    ++icent;
		    }
		}
		talk("Recovered "+icent+" centrosomes");
		selectedCross=rootCross;
		showAllCents();
	     }
	}
   
	public void drawCents(Graphics g,int xorg,int yorg) {
	    CrossMark cm = rootCross;
	    g.setColor(Color.green);
	    while(!cm.isLast()) {
		cm = cm.next;
		cm.draw(g, xorg, yorg);
		}
	    g.setColor(Color.magenta);
	    selectedCross.highlight(g, xorg, yorg);
	    }
	    
	public void deleteAllCentrosomes(){
	    CrossMark cm = rootCross;
	    while(!cm.isLast()) cm=cm.next; // go to the last centrosome
	    while(!cm.isListRoot())
			cm = cm.excise();
		rootCross = new CrossMark(this); // this discards old listRoot and installs a virgin root
	    }

 	public void hideAllCents() {
	    CrossMark cm = rootCross;
	    while(!cm.isLast()) {
		cm = cm.next;
		cm.disappear();
		}
	    }

 	public void showAllCents() {
	    CrossMark cm = rootCross;
	    while(!cm.isLast()) {
		cm = cm.next;
		cm.appear();
		}
	    }

   	private void primeMouseForCentrosomes(int whatTask) {
		actOnIncomingMouseLocs=true;
   		if(picJPanel != null) {
			picJPanel.primeMouseForTask(whatTask,this);
			picJPanel.parent.show();
			picJPanel.requestFocus();
			}
		}
	
	public CrossMark nearestCentTo(int [] xyz) {
	    CrossMark cm = rootCross;
	    double dst, dist = 777777.;
	    CrossMark ClosestCrossMark = cm;
	    while(!cm.isLast()) {
		cm = cm.next;
		dst = cm.distanceTo(xyz);
		if(dst<dist) {
		    dist=dst;
		    ClosestCrossMark=cm;
		    }
		}
	    return ClosestCrossMark;
	    }

	public void processMouseClick(double [] mouseLoc, int doWhat) {
		//  this method is called only by picJPanel after  primeMouseForTask was called
talk("mouse loc came back as ("+mouseLoc[0]+", "+mouseLoc[1]+", "+mouseLoc[2]+")");
	    int [] xyz = {(int)(mouseLoc[0]+.499),(int)(mouseLoc[1]+.499),
			    (int)(mouseLoc[2]+.499)};
	    if(actOnIncomingMouseLocs) switch (doWhat) {
		case PICK_NEAREST_CENT:	
		    selectedCross = nearestCentTo(xyz);
		    selectedCross.appear();
		    reDraw();	
		    break;
		    
		case MOVE_SELECTED_CENT:
		    selectedCross.moveTo(xyz);
		    reDraw();		
		    break;
		    
		case ADD_NEW_CENT:
		    selectedCross = 
		      selectedCross.insertNewCrossMark(xyz, 10, this);
		    selectedCross.appear();
		    reDraw();		
		    break;
		}
	    else
		talk("No action taken by Centrosome Locator because mouse news arrived too late");
		}
		
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
    		actOnIncomingMouseLocs=false; // defeat response to foreign mouse news
    		// if response did not come before some button on this panel was pushed...
			if(arg.equals("GoTo selected centrosome")) {
			    if(selectedCross.isListRoot()) {
				talk("there is no centrosome to go to yet");
				}
			selectedCross.appear();
			picJPanel.gotosection((selectedCross.tellAbsLocation())[2]); 
			}
			if(arg.equals("Select first centrosome")) {
				if(rootCross.isLast()) {
				    selectedCross=rootCross;
				    talk("there are no centrosomes yet");
				    }
				else
				    selectedCross=rootCross.next;
				selectedCross.appear();
				selectedCross.tellStats();
				reDraw();
				}
				
			if(arg.equals("shrink selected centrosome")) {
			    selectedCross.shrink();
			    reDraw();
			    }
			
			if(arg.equals("enlarge selected centrosome")) {
			    selectedCross.grow();
			    reDraw();
			    }
			
			if(arg.equals("select next centrosome")) {
				if(selectedCross.isLast()) {
				    talk("you are at the last centrosome");
				    }
		 		else
				    selectedCross = selectedCross.next;
				selectedCross.appear();
				selectedCross.tellStats();
				reDraw();
		 		}
			if(arg.equals("select previous centrosome")) {
				if(selectedCross.isFirst()) {
				    talk("there is no previous centrosome");
				    }
				else
				    selectedCross = selectedCross.prior;
				selectedCross.appear();
				selectedCross.tellStats();
				reDraw();
				}
			if(arg.equals("DELETE SELECTED CENTROSOME")) {
				selectedCross = selectedCross.excise();
				selectedCross.appear();
				reDraw();
				}
			if(arg.equals("redraw")) {
				reDraw();
				}
			if(arg.equals("add new centrosome at next click")) { 
				talk("add new centrosome at next mouse click");
				primeMouseForCentrosomes(ADD_NEW_CENT);
				}

			if(arg.equals("next click picks nearest cent")) { 
				talk("next mouse picks nearest centrosome");
				primeMouseForCentrosomes(PICK_NEAREST_CENT);
				}
			if(arg.equals("next click moves selected cent")) { 
				talk("next mouse relocates selected centrosome");
				primeMouseForCentrosomes(MOVE_SELECTED_CENT);
				}				
			if(arg.equals("print shifts/centrosome data file")) { 
	    		    ArchiveMarks disker = new ArchiveMarks();
			    disker.writeCentrosomeList(this,
				picJPanel.curStack.Xshifts,
				    picJPanel.curStack.Yshifts, 
					picJPanel.curStack.Zshifts);
			    disker=null; 
			    talk("print file with shifts/centrosome data");
			    }
			if(arg.equals("hide all centrosomes")) { 
				hideAllCents();
				reDraw();
				}
			if(arg.equals("show all centrosomes")) { 
				showAllCents();
				reDraw();
				}
    }
   
   private void reDraw() {
       picJPanel.reDraw();
    }
   
	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

class CrossMark {
    int [] absloc = {0, 0, 0};
    int radius = 8;
    Centrosomes parent;
    boolean isVisible=false;
    CrossMark prior=null;
    CrossMark next=null;
    boolean ifLinkedListRoot=false; // the root centrosome does nothing
	// cannot be deleted, does not draw;
    
    public CrossMark(int [] xyz, int rad, Centrosomes parent) {
	this.parent = parent;
	radius=rad;
	absloc[0]=xyz[0];
	absloc[1]=xyz[1];
	absloc[2]=xyz[2];
	}
	
    public CrossMark(Centrosomes parent) { // create the linked list root
	this.parent = parent;
	radius=2;
	absloc[0]=0;
	absloc[1]=0;
	absloc[2]=0;
	prior=null;
	next=null;
	ifLinkedListRoot=true;
	}
	
    public void moveTo(int [] xyz) {
	absloc[0]=xyz[0]; absloc[1]=xyz[1]; absloc[2]=xyz[2];
	}

    public double distanceTo(int [] xyz) {
	double dd = xyz[0] - absloc[0];
	double dist = dd*dd;
	dd = xyz[1] - absloc[1];
	dist += (dd*dd);
	dd = xyz[2] - absloc[2];
	dist += (dd*dd);
	return(Math.sqrt(dist));
	}
		
    public void grow() {
	++radius;
	talk("radius grows to "+radius);
	}
	
     public void shrink() {
	if(--radius <1) radius=1;;
	talk("radius shrinks to "+radius);
	}
	
    public boolean isListRoot() {
	return ifLinkedListRoot;
	}

    public boolean isFirst() {
	if(ifLinkedListRoot || prior.isListRoot()) return true;
	else return false;
	}

    public boolean isLast() {
	if(next==null) return true;
	else return false;
	}

    public CrossMark excise() {
	if(isListRoot()) return this;
/* before...
centA.next-->  this.next----->
centA<----\    this<------\   centB
           \---this.prior  \--centB.prior


after...
centA.next-->  centB.next----->
centA<----\    centB   
           \---centB.prior 

 */
	if(!isLast()) {
	    prior.next = next;	   
	 	next.prior = prior;
	 	}
	else 
	    prior.next=null;
	next=null;
	if(!prior.isLast()) 
	    return prior.next;
	else
	    return prior; // there is always a prior (possibly the List root)
	}

    public CrossMark insertNewCrossMark(int [] xyz, int rad,  
		Centrosomes parent) {
	CrossMark newcent = new CrossMark(xyz, rad, parent);
/* before...
centA.next-->  this.next----->
centA<----\    this<------\   centB
           \---this.prior  \--centB.prior

after...
centA.next-->  this.next-->  newcent.next----->
centA<---\     this<-----\   newcent<------\    centB        
          \----this.prior \--newcent.prior  \---centB.prior

 */
	newcent.next = this.next;
	if(!isLast()) next.prior=newcent;
	newcent.prior=this;
	this.next=newcent;
	talk("New centrosome added...");
	newcent.tellStats();
	return newcent;
	}
   
    public CrossMark previousCross() {
	if(prior.ifLinkedListRoot) return this;
	return prior;
	}
	
    public CrossMark nextCross() {
	if(next==null) return this;
	return next;
	}
	
    public void setRadius(int newrad) {
	radius = newrad;
	}
	
    public int tellRadius() {
	return(radius);
	}

    public int [] tellAbsLocation() {
	int [] xyz = {absloc[0], absloc[1], absloc[2]};
	return xyz;
	}

    public  void tellStats() {
	if(isListRoot()) {
		talk("I'm not a centrosome; i'm the list root");
		return;
		}
	talk("centrosome of radius "+radius+" is at ("+absloc[0]+",  "+absloc[1]+",  "+absloc[2]+")");
	}
	
    public void draw(Graphics g, int xorg, int yorg) {
      if(!ifLinkedListRoot && isVisible) {
	int dia = (int)(2.*radius);
	if(dia<1) dia=1;
	int x = (absloc[0]-radius + xorg);
	int y = (absloc[1]-radius + yorg);
	g.drawOval(x, y, dia,  dia);
	}
      }
     
    public void appear() {
	isVisible=true;
	}
      
    public void disappear() {
	isVisible=false;
	}
      
    public void highlight(Graphics g, int xorg, int yorg) { // by drawing a tiny dot...
      if(!ifLinkedListRoot && isVisible) {
		int x = absloc[0]+xorg;
		int y = absloc[1]+yorg;
		g.drawLine(x-10, y, x+10, y);
		g.drawLine(x, y+10, x, y-10);
		}
     }

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}
