package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;
/* all requests from a LightSuckerClient object to the hub Deconvolver object pass through this interface
which will eventually implement all transactions using TCPIP sockets */

class ConvolverInterface {
	LightSuckerClientInterface LSCI;
	String uniqueID="123";
	
	public ConvolverInterface(LightSuckerClientInterface LSCI,String uniqueID) {
		this.LSCI = LSCI;
		this.uniqueID = new String(uniqueID);
		}
		
	public void sepuku() {
		LSCI = null;
		}
	
	public synchronized void DSDreport(String stg) {
		LSCI.DSDreport(stg,uniqueID);
		}

	public synchronized boolean isGameOver() {
		return LSCI.isGameOver(uniqueID);
		}
	
	public synchronized int [] getAssignedSectionsToDeconvolve() {
		return LSCI.getAssignedSectionsToDeconvolve(uniqueID);
		}
	
	public synchronized PSFdata getPSFData() {
		return LSCI.getPSFData(uniqueID);
		}
	
	public void report1(String stg) {
		LSCI.report1(stg, uniqueID);
		}
	
	public synchronized int getNiceSleep() {
		return LSCI.getNiceSleep(uniqueID);
		}
	
	public synchronized int getSectsInStack() {
		return LSCI.getSectsInStack(uniqueID);
		}
	
	public synchronized double getNoGlow() {
		return LSCI.getNoGlow(uniqueID);
		}
	
	public synchronized boolean ifPaused() {
		if(LSCI.ifPaused(uniqueID) > 0)
			return true;
		else
			return false;
		}
	
	public synchronized int [] getSectionParams(int whichSection) {
		return LSCI.getSectionParams(whichSection, uniqueID);
		}
	
	public synchronized double getMainParameter() {
		return LSCI.getMainParameter(uniqueID);
		}
	
	public synchronized float [] copyOrigSect(int whichSection, int npix) {
		float [] retn = new float[npix];
		LSCI.copyOrigSect(whichSection, retn, uniqueID);
		return retn;
		}

	public synchronized float [] copyLeaksum(int whichSection, int npix) {
		float [] retn = new float[npix];
		LSCI.copyLeaksum(whichSection, retn, uniqueID);
		return retn;
		}

	public synchronized void recordLightLeakedFromSection(int deconSectNum,float [] leaksum, int deconSectStatus) {
		talk("ConvolverInterface.recordLightLeakedFromSection("+deconSectNum+" from "+uniqueID);
		LSCI.recordLightLeakedFromSection(deconSectNum,leaksum,deconSectStatus, uniqueID);
		}
		
	static  synchronized void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}