package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;
import java.util.*;
import java.io.*;
import java.net.*;

class FindServerPortOnSubnet {
	IPProbe [] theProbes;
	String iprefix = "";
	int portNum=-1;
	int waitForProbesToStop = 100;
	String unt = "untested",failed = "fail";
	int waitCount = 10;
	sectionConsumerClient parent=null;

	public void sepuku() {
		}
		
	public FindServerPortOnSubnet(int portNum,String iprefix, sectionConsumerClient parent) {	
		theProbes = new IPProbe[256];
		this.parent =  parent;
		this.iprefix=iprefix;
		this.portNum=portNum;
		}
		
	public void gotAServerConnection(String theIP, Socket ss) {
		parent.goodIP = theIP;
		//talk("FindServerPortOnSubnet.gotAServerConnection() got IP = "+theIP);
		parent.s=ss;
		//talk("FindServerPortOnSubnet.gotAServerConnection() got serverSocket = "+ss);
		//talk("Again, FindServerPortOnSubnet.gotAServerConnection() got IP = "+theIP);
		//talk("Again, FindServerPortOnSubnet.gotAServerConnection() got serverSocket = "+ss);
		} 	
		
	private void stopAllThreads() {
		//talk("stopAllThreads()");
		for(int i=0;i<256;i++) {
			theProbes[i].stop();
			theProbes[i].parent = null;
			theProbes[i]=null;
			}
		}
	
	public boolean snoop() { // returns an array of indices into the 
							// ipVerdicts and theSockets arrays  
							// that locate valid ports. A null array
							// means no valid ports found.
		// after calling this method, the user should dispose of everything.						
		int i,j;
		waitCount = 9;
		//talk("FindServerPortOnSubnet.snoop() creates theProbes");
		for(i=0;i<256;i++) { // create all the probes
			theProbes[i] = new IPProbe(i,portNum,iprefix,this);
			}
		//talk("FindServerPortOnSubnet.snoop() sleeps(300)");
		try{ (Thread.currentThread()).sleep(300);}
		catch (InterruptedException e) {} 
		//talk("FindServerPortOnSubnet.snoop() starts theProbes' threads ");
		for(i=255;i>=0;i--) { // start their threads
			theProbes[i].start();
			}
		//talk("FindServerPortOnSubnet.snoop() sleeps(500) ");
		try{ (Thread.currentThread()).sleep(500);}
		catch (InterruptedException e) {} 
		while(parent.s==null) {// wait a reasonable time until one finds the server
			talk("waitCount = "+waitCount);
			if(waitCount <=1) {// we're done; return the list of hits
				// eliminate all the probe threads.
				//talk("stop all the threads just in case");
				stopAllThreads();
				talk("Apparently no server port opened");
				return false;
				}
			--waitCount;
			try{ (Thread.currentThread()).sleep(300);}
			catch (InterruptedException e) {} 
			}
		// if fall through, then ss has become a valid socket
		talk("FindServerPortOnSubnet returns socket on IP="+parent.goodIP);
		stopAllThreads();
		return true;
		}
		
	static void talk(String p) {
		System.out.println(p);
	}	

}