package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class GoToHotSpots extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel;
	int nomwidth=75,nomheight=170;
	JTextField sectA,sectB,sectC,sectD,sectE,sectF,sectG,sectH,sectI,sectJ;	
	
    public GoToHotSpots(ShowPicJPanel picJPanel,int maxframes) {   
    super("GoTo Section");
    this.picJPanel = picJPanel;
    double inc = (double)maxframes/9.0;
    double aspot = 0.;
    String stg;
    WidgetMaker wmk = new WidgetMaker(this);
    int rr=130, gg=255, bb=130;
    getContentPane().setLayout(new BorderLayout()); 
    setSize(nomwidth, nomheight);
	JPanel goPan= new JPanel();
	stg = ""+(int)aspot; aspot += inc;
	sectA=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectB=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectC=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectD=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectE=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectF=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectG=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectH=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(int)aspot; aspot += inc;
	sectI=wmk.makeAJTextField(stg,4,rr,gg,bb);
	rr += 10; gg -= 10; bb+=7;
	stg = ""+(maxframes-1);
	sectJ=wmk.makeAJTextField(stg,4,rr,gg,bb);
	
	goPan.setLayout(new GridLayout(0, 2));
    rr=130;   gg=255;   bb=130;
	goPan.add(wmk.makeAJButton("A",rr,gg,bb));		goPan.add(sectA);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("B",rr,gg,bb));		goPan.add(sectB);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("C",rr,gg,bb));		goPan.add(sectC);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("D",rr,gg,bb));		goPan.add(sectD);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("E",rr,gg,bb));		goPan.add(sectE);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("F",rr,gg,bb));		goPan.add(sectF);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("G",rr,gg,bb));		goPan.add(sectG);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("H",rr,gg,bb));		goPan.add(sectH);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("I",rr,gg,bb));		goPan.add(sectI);
	rr += 10; gg -= 10; bb+=7;
	goPan.add(wmk.makeAJButton("J",rr,gg,bb));		goPan.add(sectJ);
	getContentPane().add("Center",goPan);
	addWindowListener(this);
  }

// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	 

	public void jumpTo(JTextField sect) {
		int jmp = getSpot(sect);
	    picJPanel.gotosection(jmp);
	    }
	   
	public int getSpot(JTextField sect) {
	    int jmp = (int)(Double.valueOf(sect.getText()).doubleValue());
	    if(jmp<0) jmp=0;
	    if(jmp >= picJPanel.curStack.NJFrames) 
	    	jmp=picJPanel.curStack.NJFrames - 1;	
	    sect.setText(""+jmp);
	    return jmp;
		}
		
	public void setSpot(JTextField sect, int jmp) {
	    if(jmp<0) jmp=0;
	    if(jmp >= picJPanel.curStack.NJFrames) 
	    	jmp=picJPanel.curStack.NJFrames - 1;	
	    sect.setText(""+jmp);
		}
		
			    
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
    	JTextField sect;
    	
	    	if(arg.equals("A")) {
				jumpTo(sectA); 
    			}
	    	if(arg.equals("B")) {
				jumpTo(sectB); 
    			}
	    	if(arg.equals("C")) {
				jumpTo(sectC); 
    			}
	    	if(arg.equals("D")) {
				jumpTo(sectD); 
    			}
	    	if(arg.equals("E")) {
				jumpTo(sectE); 
    			}
	    	if(arg.equals("F")) {
				jumpTo(sectF); 
    			}
	    	if(arg.equals("G")) {
				jumpTo(sectG); 
    			}
	    	if(arg.equals("H")) {
				jumpTo(sectH); 
    			}
	    	if(arg.equals("I")) {
				jumpTo(sectI); 
    			}
	    	if(arg.equals("J")) {
				jumpTo(sectJ); 
    			}
    }

  public void archiveHotSpots(ArchiveMarks disker, boolean ifWrite) {
	double spot;
	int ispot;
	double badval = 77777.7;
        if(ifWrite) {
        	spot=(double)getSpot(sectA);
	   		disker.writeNum(spot, " = section A hot spot");
        	spot=(double)getSpot(sectB);
	   		disker.writeNum(spot, " = section B hot spot");
        	spot=(double)getSpot(sectC);
	   		disker.writeNum(spot, " = section C hot spot");
        	spot=(double)getSpot(sectD);
	   		disker.writeNum(spot, " = section D hot spot");
        	spot=(double)getSpot(sectE);
	   		disker.writeNum(spot, " = section E hot spot");
        	spot=(double)getSpot(sectF);
	   		disker.writeNum(spot, " = section F hot spot");
        	spot=(double)getSpot(sectG);
	   		disker.writeNum(spot, " = section G hot spot");
        	spot=(double)getSpot(sectH);
	   		disker.writeNum(spot, " = section H hot spot");
        	spot=(double)getSpot(sectI);
	   		disker.writeNum(spot, " = section J hot spot");
        	spot=(double)getSpot(sectJ);
	   		disker.writeNum(spot, " = sectionJ  hot spot");
		}
	else {
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectA,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectB,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectC,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectD,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectE,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectF,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectG,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectH,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectI,ispot);
		ispot = (int)(disker.getNextFileDouble(badval));
		setSpot(sectJ,ispot);
	      }
	}

	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

