package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  import javax.swing.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;


/* This dialog lets user input scale factor */
public class GotoDialog extends MyDialog {


	JButton	selectJButton, cancelJButton;
	JTextField	itsText;
	int			frame;

	GotoDialog(JFrame parent, DialogCallback callback_class, int dlog_id, String stack_name, int cur_frame) {
		super(parent, "Goto frame", false, callback_class, dlog_id);

		frame = cur_frame;
		
		setSize(210, 110);
		setLayout(new FlowLayout());
		add(new JLabel("frame # "));
		itsText = new JTextField(String.valueOf(cur_frame), 4);
		add(itsText);
		add(new JLabel("in stack " + stack_name));
		selectJButton = new JButton("OK");
		add(selectJButton);
		cancelJButton = new JButton("Cancel");
		add(cancelJButton);
		show();
	}
		
	synchronized public boolean action(Event e, Object arg) {
        if (e.target == selectJButton ) {
            setVisible(false);         // hide the JFrame
            good = true;
            frame = (new Integer(itsText.getText())).intValue();
            dlogDone();
            return true;
         }
         else if(e.target == cancelJButton) {
         	setVisible(false);
         	good = false;
         	dlogDone();
         	return true;
         }
        // anything else, we use the default behavior: JFrame.handleEvent()
        return super.handleEvent(e);
    }

	int getJFrame() {
		return(frame);
	}

}