package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class MoveMarksAndSections extends JFrame  implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	int nomwidth=240, nomheight=122;
	ShowPicJPanel picJPanel;
	String markMoves="mark moves",sectMoves="sect moves";
	String curMarkStg = "m0", curMarkString="mark0";
	String click2MoveStg="clik2mv ", click2Go="go to "; 
	boolean redJButtonsMoveMark=false,greenJButtonsMoveMark=false,
		blueJButtonsMoveMark=false;
	JButton rwhatMoves,gwhatMoves,bwhatMoves,rwhatClickdoes,
		gwhatClickdoes,bwhatClickdoes;

	RGBMarker myMark=null;
	int imyMark=0;
	final static int GOTO_SLICE_DLOG = 2;
	final static int MOUSE_PICKS_A_MARK = 10;
	final static int MOUSE_MOVES_SELECTED_MARK = 11;
	final static int MOUSE_REPORTS_LOCATION_COLORS = 12;
	final static int MOUSE_MOVES_RED_SELECTED_LEAF = 18;
	final static int MOUSE_MOVES_GREEN_SELECTED_LEAF = 19;
	final static int MOUSE_MOVES_BLUE_SELECTED_LEAF = 20;
	final static int MOUSE_PICKS_MEASURE_MARK_1 = 21;
	final static int MOUSE_PICKS_MEASURE_MARK_2 = 22;
	final static int PICK_NEAREST_CENT = 70;
	final static int MOVE_SELECTED_CENT = 71;
	final static int ADD_NEW_CENT = 72;

 public MoveMarksAndSections(ShowPicJPanel picJPanel) {   
    super("move marks/sections");
    this.picJPanel=picJPanel;
	Color myBlue = 	new Color(150,150,255);
	JPanel redPan,greenPan,bluePan,buttonJPanel;
 	getContentPane().setLayout(new BorderLayout()); 
    setSize(nomwidth, nomheight);
	setBackground(myBlue);
	WidgetMaker wmk = new WidgetMaker(this);

	buttonJPanel = new JPanel();
	buttonJPanel.setLayout(new GridLayout(0, 1));

   	redPan = new JPanel();
    redPan.setLayout(new GridLayout(2,6));
    redPan.setBackground(Color.red);
    rwhatClickdoes = wmk.makeAJButton(click2Go+curMarkStg,Color.red);
    rwhatMoves = wmk.makeAJButton(sectMoves,Color.red);  
    redPan.add(wmk.makeAJButton("up",Color.red)); 
    redPan.add(wmk.makeAJButton("<--",Color.red)); 
	redPan.add(wmk.makeAJButton("--Z",Color.red));  
	redPan.add(rwhatMoves);
    redPan.add(wmk.makeAJButton("down",Color.red)); 
    redPan.add(wmk.makeAJButton("-->",Color.red)); 
	redPan.add(wmk.makeAJButton("++Z",Color.red)); 
	redPan.add(rwhatClickdoes);

    greenPan = new JPanel();
    greenPan.setLayout(new GridLayout(2,6));
    greenPan.setBackground(Color.green);
            
    gwhatMoves = wmk.makeAJButton(sectMoves+" ",Color.green);  
    gwhatClickdoes = wmk.makeAJButton(click2Go+curMarkStg+" ",Color.green);
    greenPan.add(wmk.makeAJButton("up ",Color.green));
    greenPan.add(wmk.makeAJButton("<-- ",Color.green)); 
	greenPan.add(wmk.makeAJButton("--Z ",Color.green)); 
	greenPan.add(gwhatMoves);
    greenPan.add(wmk.makeAJButton("down ",Color.green)); 
    greenPan.add( wmk.makeAJButton("--> ",Color.green)); 
	greenPan.add( wmk.makeAJButton("++Z ",Color.green));  
	greenPan.add(gwhatClickdoes);
            
    bluePan = new JPanel();
    bluePan.setLayout(new GridLayout(2,4));
    bluePan.setBackground(myBlue);
        
	bwhatMoves = wmk.makeAJButton(" "+sectMoves,myBlue);  
	bwhatClickdoes = wmk.makeAJButton(" "+click2Go+curMarkStg,myBlue);
	bluePan.add(wmk.makeAJButton(" up",myBlue));
	bluePan.add(wmk.makeAJButton(" <--",myBlue)); 
	bluePan.add(wmk.makeAJButton(" --Z",myBlue)); 
	bluePan.add(bwhatMoves);
	bluePan.add(wmk.makeAJButton(" down",myBlue)); 
	bluePan.add(wmk.makeAJButton(" -->",myBlue)); 
	bluePan.add(wmk.makeAJButton(" ++Z",myBlue)); 
	bluePan.add(bwhatClickdoes);
    
 	buttonJPanel.add(redPan);	
	buttonJPanel.add(greenPan);	
	buttonJPanel.add(bluePan);        

	getContentPane().add("Center", buttonJPanel);
	addWindowListener(this);
	}
 	
	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

   	private void primeMouseToMoveSectionsAndMarks(int whatTask) {
   		if(picJPanel != null) {
			picJPanel.primeMouseForTask(whatTask);
			picJPanel.parent.show();
			picJPanel.requestFocus();
			}
		}
	
    public void adoptNewMarker(int iwh, RGBMarker myMark) {
	this.myMark=myMark;
	curMarkStg="m"+iwh;
	curMarkString="mark"+iwh;
	imyMark=iwh;
	if(redJButtonsMoveMark) {
		rwhatMoves.setLabel(markMoves);
		rwhatClickdoes.setText(click2MoveStg+curMarkStg);	    
		}
	else {
		rwhatMoves.setText(sectMoves);
		rwhatClickdoes.setText(click2Go+curMarkStg);
		}

	if(greenJButtonsMoveMark) {
		gwhatMoves.setText(markMoves+" ");
		gwhatClickdoes.setText(click2MoveStg+curMarkStg+" ");	    
		}
	else {
		gwhatMoves.setText(sectMoves+" ");
		gwhatClickdoes.setText(click2Go+curMarkStg+" ");
		}

	if(blueJButtonsMoveMark) {
		bwhatMoves.setText(" "+markMoves);
		bwhatClickdoes.setText(" "+click2MoveStg+curMarkStg);	    
		}
	else {
		bwhatMoves.setText(" "+sectMoves);
		bwhatClickdoes.setText(" "+click2Go+curMarkStg);
		}
	}
	
// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}	

// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
    	if(arg.equals("-->")) {
    			picJPanel.redShift(1,0,0); 
    			}
		if(arg.equals("<--")) {
				picJPanel.redShift(-1,0,0); 
				}
		if(arg.equals("up")) {picJPanel.redShift(0,-1,0);}
		if(arg.equals("down")) {picJPanel.redShift(0,1,0);}
		if(arg.equals("++Z")) {picJPanel.redShift(0,0,1);}
		if(arg.equals("--Z")) {picJPanel.redShift(0,0,-1);}
		
    	if(arg.equals("--> ")) {picJPanel.greenShift(1,0,0);}
		if(arg.equals("<-- ")) {picJPanel.greenShift(-1,0,0);}
		if(arg.equals("up ")) {picJPanel.greenShift(0,-1,0);}
		if(arg.equals("down ")) {picJPanel.greenShift(0,1,0);}
		if(arg.equals("++Z ")) {picJPanel.greenShift(0,0,1);}
		if(arg.equals("--Z ")) {picJPanel.greenShift(0,0,-1);}
		
    	if(arg.equals(" -->")) {picJPanel.blueShift(1,0,0);}
		if(arg.equals(" <--")) {picJPanel.blueShift(-1,0,0);}
		if(arg.equals(" up")) {picJPanel.blueShift(0,-1,0);}
		if(arg.equals(" down")) {picJPanel.blueShift(0,1,0);}
		if(arg.equals(" ++Z")) {picJPanel.blueShift(0,0,1);}
		if(arg.equals(" --Z")) {picJPanel.blueShift(0,0,-1);}
				
		if(arg.equals(markMoves)) { // red rWhatMoves button pressed;  toggle to"section moves" mode
				redJButtonsMoveMark=false;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				rwhatMoves.setText(sectMoves);
				rwhatClickdoes.setText(click2Go+curMarkStg);
				}
		if(arg.equals(click2Go+curMarkStg)) { // red click2Go button pressed
					// go to red leaf of selected mark.
				int rz = (int)((myMark.tellAbsLoc(0))[2]);
				talk("Red leaf of "+curMarkString+" is in section "+rz);
				picJPanel.curStack.showAJFrame(rz);
				}
		if(arg.equals(sectMoves)) { // red rWhatMoves button pressed;  toggle to"mark moves" mode
				redJButtonsMoveMark=true;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				rwhatMoves.setText(markMoves);
				rwhatClickdoes.setText(click2MoveStg+curMarkStg);
				}
		if(arg.equals(click2MoveStg+curMarkStg)) { // green gWhatMoves button pressed;  toggle to"mark moves" mode
				redJButtonsMoveMark=true;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				talk("next mouse click moves red leaf of "+curMarkString);
				picJPanel.primeMouseForTask(MOUSE_MOVES_RED_SELECTED_LEAF);
				}
		
		if(arg.equals(markMoves+" ")) { //green gWhatMoves button pressed;  toggle to"section moves" mode
				greenJButtonsMoveMark=false;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				gwhatMoves.setText(sectMoves+" ");
				gwhatClickdoes.setText(click2Go+curMarkStg+" ");
				}
		if(arg.equals(click2Go+curMarkStg+" ")) { // green click2Go button pressed
					// go to green leaf of selected mark.
				int gz = (int)((myMark.tellAbsLoc(1))[2]);
				talk("Green leaf of "+curMarkString+" is in section "+gz);
				picJPanel.curStack.showAJFrame(gz);
				}
		if(arg.equals(sectMoves+" ")) { // green gWhatMoves button pressed;  toggle to"mark moves" mode
				greenJButtonsMoveMark=true;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				gwhatMoves.setText(markMoves+" ");
				gwhatClickdoes.setText(click2MoveStg+curMarkStg+" ");
				}
		if(arg.equals(click2MoveStg+curMarkStg+" ")) { // green gWhatMoves button pressed;  toggle to"mark moves" mode
				greenJButtonsMoveMark=true;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				talk("next mouse click moves green leaf of "+curMarkString);
				picJPanel.primeMouseForTask(MOUSE_MOVES_GREEN_SELECTED_LEAF);
				}

		if(arg.equals(" "+markMoves)) { // blue bWhatMoves button pressed;  toggle to"section moves" mode
				blueJButtonsMoveMark=false;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				bwhatMoves.setText(" "+sectMoves);
				bwhatClickdoes.setText(" "+click2Go+curMarkStg);
				}
		
		if(arg.equals(" "+click2Go+curMarkStg)) { // blue click2Go button pressed
					// go to blue leaf of selected mark.
				int bz = (int)((myMark.tellAbsLoc(2))[2]);
				talk("Blue leaf of "+curMarkString+" is in section "+bz);
				picJPanel.curStack.showAJFrame(bz);
				}
		
		
		if(arg.equals(" "+sectMoves)) { // blue bWhatMoves button pressed;  toggle to"mark moves" mode
				blueJButtonsMoveMark=true;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				bwhatMoves.setText(" "+markMoves);
				bwhatClickdoes.setText(" "+click2MoveStg+curMarkStg);
				}		
		if(arg.equals(" "+click2MoveStg+curMarkStg)) { // green gWhatMoves button pressed;  toggle to"mark moves" mode
				blueJButtonsMoveMark=true;
				picJPanel.setMoveSectionsOrMarkFlags(redJButtonsMoveMark,
					greenJButtonsMoveMark,blueJButtonsMoveMark);
				talk("next mouse click moves blue leaf of "+curMarkString);
				picJPanel.primeMouseForTask(MOUSE_MOVES_BLUE_SELECTED_LEAF);
				}
    }

   	private void primeMouseForMarkers(int whatTask) {
   		if(picJPanel != null) {
			picJPanel.primeMouseForTask(whatTask);
			picJPanel.parent.show();
			picJPanel.requestFocus();
			}
		}
	
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

