package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class PSFdata { // this holds all the relevant data from a DeconvolverPSF object
	int nradpts=10,numProfiles=2,beadSect=0;
	double dxyorig, dzorig; // the voxel size of the stack from which the PSF was measured

	int numXYZpoints=0;
	
	int nSectsUp=0,nSectsDown=0;
	int [][] delxZup,delyZup; // the first index corresponds to the z-section displacement
								// at or above the point  
	double [][] glowZup; // the second index gives the glow-point number
	int [] numPtsInUpSects;

	int [][] delxZdown,delyZdown; // the first index corresponds to the z-section displacement
								// at or below the point  
	double [][] glowZdown; // the second index gives the glow-point number
	int [] numPtsInDownSects;
	
	double dxy,dz; // the voxel size of the stack to be deconvolved
	
	int minx=0,maxx=0,miny=0,maxy=0;
	int sectionPicDimension=1;

}