package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class PointSpreadCanvas extends Canvas implements  java.awt.event.MouseListener {
	int lastX=0;
	int lastY=0;
	int mouseStartX = 0;
	int mouseStartY = 0;
	writePointSpreadFile grandParent=null;
	PointSpreadCanvasFrame parent = null;
	int canvaswidth=512,canvasheight=256;
	int parentwidth;
	double [][]radProfile=null;
	int nradpts=0;
	int numProfiles=1;
	int leftBarWidth=10;
	int whichZabs=-1;
	int beadProfNum=0;
	int maxUpSect=0;
	int minDownSect=-1;
	int absDeliz=1;
	int midline=0;
	double beadRadSq=1.,dxy=1.,dz=1.;
	
	public void sepuku() {
		grandParent=null;
		parent=null;
		radProfile=null;
		}
		

	public double getCurrentZheight() {
			return (whichZabs*dz);
			}
		
	public void paint(Graphics g) {
		//talk("This should never happen. PointSpreadCanvas.paint() called");
		paint2D((Graphics2D)g);
		}
		
	public void update(Graphics g) {
		// talk("PointSpreadCanvas.update() called. Should never happen");
		paint2D((Graphics2D)g);
		}

	public void update2D(Graphics2D g) {
		paint2D(g);
		}

	public void paint2D(Graphics2D g) {
	// draw horiz grid grid marks
	// draw up/down patches
	// put in text field to tell which section
		parent.resetSize(parentwidth,canvasheight+20);
		int dim = 255-(int)(.49 + grandParent.getDimThresh());
		boolean ifbright=true;
		Color brightColor = Color.yellow;
		Color dimColor = Color.green;
		Color inBeadColor = Color.cyan;
		int i,ns,xx,ht;
		double zsqFromBead=1,rad;
		
// paint main background
		g.setColor(new Color(100,0,80));
		g.fillRect(0,0,parentwidth,canvasheight+20);
		
// paint the instructions every time, in case they get overwritten.
		int instructionsIndent = canvaswidth+5;
		g.setColor(Color.magenta);
		int yy = 12;	
		g.drawString("POINT SPREAD PROFILES",instructionsIndent,yy);
		yy +=30;
		g.setColor(Color.white);
			
		g.drawString("Click in blue vertical",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("bar to pick |delta z|.",instructionsIndent,yy);
		yy +=20;
			
		g.drawString("Click in cyan rectangles",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("to increment/decrement",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("|delta z|.",instructionsIndent,yy);
		yy +=20;
			
		g.drawString("Enter dimThreshold values",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("in main window to change",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("magenta cutoff level.",instructionsIndent,yy);
		yy +=20;
			
		g.drawString("Right profile is above",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("bead and left profile is",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("below bead center.",instructionsIndent,yy);
		yy +=20;
			
		g.drawString("Blue ticks mark 1 micron",instructionsIndent,yy);
		yy +=15;
			
		g.drawString("displacements from bead.",instructionsIndent,yy);
							
		g.setColor(Color.darkGray);
		g.fillRect(0,0,canvaswidth,255);
		g.setColor(Color.blue);
		g.fillRect(0,0,leftBarWidth,255);
		g.setColor(Color.cyan);
		g.fillRect(0,0,leftBarWidth,5);
		g.fillRect(0,250,leftBarWidth,255);
		g.setColor(Color.magenta);
		g.drawLine(leftBarWidth,dim,canvaswidth,dim);
		
		// draw bar corresponding to profile
		ht = 250 - (245*whichZabs)/absDeliz;
		g.setColor(Color.white);
		g.drawLine(0,ht,leftBarWidth,ht);		
		grandParent.reportProfile(whichZabs*(grandParent.dz));
		zsqFromBead = dz*whichZabs;
		g.setColor(Color.white);
		g.drawString(("|delta z| = "+grandParent.trunc(zsqFromBead)),
				instructionsIndent,27);
		zsqFromBead = zsqFromBead*zsqFromBead;
		
		if(whichZabs>=0) {				
		  ns = whichZabs+beadProfNum;
		  if(ns < maxUpSect) {
		   ns -= minDownSect;
		   g.setColor(brightColor);
		   for(i=0;i<nradpts;i++) { // draw the profile above the bead on the right of midline
				xx = i+midline+1;
				if(radProfile[ns][i] >= 0.)  {
					ht = (int)(255.499-radProfile[ns][i]);
					g.setColor(dimColor);
					g.drawLine(xx,255,xx,ht);
					
					if(ht<dim) {
						g.setColor(dimColor);
						g.drawLine(xx,255,xx,dim);
						rad = i*dxy;
						if(rad*rad + zsqFromBead <= beadRadSq)
		  					g.setColor(inBeadColor);
		  				else
		  					g.setColor(brightColor);
						g.drawLine(xx,dim-1,xx,ht);
						ifbright=true;
						}
				  	}
			    }
			   }
			 	

		  ns = beadProfNum-whichZabs;
		  if(ns >= minDownSect) {
		   ns -= minDownSect;
		   g.setColor(brightColor);
		   ifbright=true;
		   for(i=0;i<nradpts;i++) { // draw the profile above the bead on the right of midline
				xx = midline-i-1;
				if(radProfile[ns][i] >= 0.)  {
					ht = (int)(255.499-radProfile[ns][i]);
					g.setColor(dimColor);
					g.drawLine(xx,255,xx,ht);
					
					if(ht<dim) {
						g.setColor(dimColor);
						g.drawLine(xx,255,xx,dim);
						rad = i*dxy;
						if(rad*rad + zsqFromBead <= beadRadSq)
		  					g.setColor(inBeadColor);
		  				else	
		  					g.setColor(brightColor);
						g.drawLine(xx,dim-1,xx,ht);
						}
				  }
			    }
			 }
			}	


		// draw the horizontal micrometer grid ticks
		int micron=0;
		int imicron = (int )(.49+micron/grandParent.dxy);
		g.setColor(Color.blue);
		while(imicron < nradpts) {
			g.drawLine(midline+1+imicron,210,midline+1+imicron,218);
			g.drawLine(midline-1-imicron,210,midline-1-imicron,218);
			++micron;
			imicron = (int )(.49+micron/grandParent.dxy);
			}		
		}
		
	public PointSpreadCanvas(PointSpreadCanvasFrame parent, writePointSpreadFile grandParent){
		int i;
		this.parent=parent;
		this.grandParent=grandParent;
		lastX=0; lastY=0;
		setBackground(new Color(64, 0, 64));
		setSize(canvaswidth,canvasheight);
		addMouseListener(this);
   		}
   	
	public void newSlate(double [][]radProfile, int nradpts, int numProfiles) {
		this.radProfile = radProfile;
		this.nradpts = nradpts;
		this.numProfiles = numProfiles;
		canvaswidth = leftBarWidth+2*nradpts;
		parentwidth = canvaswidth+50;
		if(parentwidth<200) parentwidth=200;
		beadRadSq  = grandParent.beadDiameter/2.;
		beadRadSq = beadRadSq*beadRadSq;
		dxy = grandParent.dxy;
		dz = grandParent.dz;
		beadProfNum = grandParent.zcen;
		maxUpSect = grandParent.highSectNum;
		minDownSect = grandParent.lowSectNum;
		if((absDeliz = beadProfNum-minDownSect) < maxUpSect-beadProfNum)
			absDeliz = maxUpSect;
		talk("minDownSect="+minDownSect+", maxUpSect="+maxUpSect+", absDeliz="+absDeliz);
		midline = leftBarWidth+nradpts;
		parent.resetSize(parentwidth,canvasheight+20);
		setSize(canvaswidth,canvasheight);
 		whichZabs=0;
 		setVisible(true);
		}
		
	public void update(Graphics2D g) {
		paint(g);
		}	    
	
	public void mouseClicked(java.awt.event.MouseEvent event) {
		// talk("Mouse Clicked at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mousePressed(java.awt.event.MouseEvent event) {
		    mouseStartX = event.getX();
		    mouseStartY = event.getY();
		    if(mouseStartX>255) mouseStartX=255;
		    if (mouseStartX<0) mouseStartX=0;
		    if(mouseStartY>255) mouseStartY=255;
		    if (mouseStartY<0) mouseStartY=0;
		}
		
		
	public void mouseEntered(java.awt.event.MouseEvent event) {
		// talk("Mouse entered at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mouseExited(java.awt.event.MouseEvent event) {
		// talk("Mouse exited at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mouseReleased(java.awt.event.MouseEvent event) {	
		int x = mouseStartX;
		int y = mouseStartY;
		if(x>2*leftBarWidth) {
			repaint();
			return;
			}
		if(y>250) { // draw previous profile
			whichZabs--;
			if(whichZabs<0) 
				whichZabs=0;
			}
		else if(y<=5) { // draw next profile
			whichZabs++;
			if(whichZabs > absDeliz) 
				whichZabs=absDeliz-1;
			}
		else 
			whichZabs = ((250-y)*absDeliz)/245;
			
			/* whichZabs = ((250-y)*absDeliz)/245;
			so (245*whichZabs)/absDeliz = 250-y
			so y = 250 - (245*whichZabs)/absDeliz */
			
		//talk("draw profile at height "+grandParent.trunc(whichZabs*grandParent.dz)+" from bead center."); 
		repaint();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}  
