package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


import java.io.*;

class RamifyRawDotPic extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	int width=100,height=190,whichStack=-1;
	int num_frames=0, sectNumToWrite=0;
	String fileName,raw01name,raw02name,raw03name;
	ZseriesMainWindow parent;
	BioradFile myfile=null;
	int nomwidth=340, nomheight=170;
	JButton doit;

	public RamifyRawDotPic(ZseriesMainWindow parent, String myfilesName) {
		this.parent = parent;
		fileName=myfilesName;
		setBackground(Color.gray);
		getContentPane().setLayout(new GridLayout(0,1));
		setSize(nomwidth,nomheight);
		setBackground(Color.gray);
		WidgetMaker wmk = new WidgetMaker(this);
		setTitle("split raw.pic-> {raw01.pic raw02.pic raw03.pic}");

		doit = wmk.makeAJButton("Create the output files",Color.gray);
		num_frames=-1;
		try {
			talk("Open .PIC file called <"+myfilesName+">");
			myfile=new BioradFile(myfilesName,true);
			}
		catch (IOException e) {
			talk("Oops. Failed to open a valid Biorad File");
			}
		if(myfile != null) {
			num_frames=myfile.num_pics;
			talk("The .PIC file has "+num_frames+" sections.");
			}
		else num_frames=0;
		setBackground(Color.gray);
		int islash = myfilesName.lastIndexOf("/");
		String stg;
		stg = myfilesName;
		getContentPane().add(wmk.makeAJLabel("Input file's name =")); 
		getContentPane().add(wmk.makeAJLabel(stg)); 
		getContentPane().add(wmk.makeAJLabel(""+myfile.width+" = width,  "+myfile.height+
			" = height.  Files to be created:"));
		if(num_frames>0) {
			raw01name = myfilesName.substring(0,islash)+"raw01.pic";
			getContentPane().add(wmk.makeAJLabel(raw01name));
			}
		if(num_frames>1) {
			raw02name = myfilesName.substring(0,islash)+"raw02.pic";
			getContentPane().add(wmk.makeAJLabel(raw02name));
			}
		if(num_frames>2) {
			raw03name = myfilesName.substring(0,islash)+"raw03.pic";
			getContentPane().add(wmk.makeAJLabel(raw03name));
			}
		getContentPane().add(doit);	
		
		addWindowListener(this);
		 }
		 
// catch button events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
    	byte [] raster = null;
    	byte [] header = null;
		Object object = event.getSource();
		RandomAccessFile outfile=null;
		String butonlobel = ((JButton)object).getLabel();
		if (object == doit) {
			if(num_frames>0) { // there's one frame to write...
				try{
					outfile = new RandomAccessFile(raw01name,"rw");
					}
				catch (IOException e) {
					talk("openWritingFile("+raw01name+") failed");
					}
	    		raster = myfile.readBioradRaster(0);
	    		header = new byte[myfile.bioradHeaderLength];
	    		for(int i = 0; i<myfile.bioradHeaderLength;i++)
	    			header[i]=myfile.header[i];
	    		header[4]=1;
	    		header[5]=0; // these two bytes encode the number of pictures in the stack.
	    		if(raster != null) {
	    			try { 
	    				outfile.write(header);
	    				outfile.write(raster);
	    				outfile.close();
	    				}
	    			catch(IOException ioe) {
	    				talk("write operation failed??? "+ioe);
	    				}
	    			outfile=null;
 	    			raster=null;
	    			}
	    			else talk("OOps could not read the biorad file raster. ");
	    		}
	    		
			if(num_frames>1) { // there's one frame to write...
				try{
					outfile = new RandomAccessFile(raw02name,"rw");
					}
				catch (IOException e) {
					talk("openWritingFile("+raw02name+") failed");
					return;
					}
	    		raster = myfile.readBioradRaster(1);
	    		if(raster != null) {
	    			try { 
	    				outfile.write(header);
	    				outfile.write(raster);
	    				outfile.close();
	    				}
	    			catch(IOException ioe) {
	    				talk("write operation failed??? "+ioe);
	    				}
	    			outfile=null;
 	    			raster=null;
	    			}
	    			else talk("OOps could not read the biorad file raster. ");
	    		}
	 
			if(num_frames>2) { // there's one frame to write...
				try{
					outfile = new RandomAccessFile(raw03name,"rw");
					}
				catch (IOException e) {
					talk("openWritingFile("+raw03name+") failed");
					return;
					}
	    		raster = myfile.readBioradRaster(2);
	    		if(raster != null) {
	    			try { 
	    				outfile.write(header);
	    				outfile.write(raster);
	    				outfile.close();
	    				}
	    			catch(IOException ioe) {
	    				talk("write operation failed??? "+ioe);
	    				}
	    			outfile=null;
 	    			raster=null;
	    			}
	    			else talk("OOps could not read the biorad file raster. ");
	    		}
			if(myfile != null)
				myfile.sepuku();
			myfile=null;
			fileName=null;
			raw01name=null;
			raw02name=null;
			raw03name=null;
	    	outfile=null;
 	    	raster=null;
 	    	header=null;
	    	setVisible(false);
        	dispose();	 		
			}
		}
	
// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
		//  talk("window closing");
		if(myfile != null)
			myfile.sepuku();
		myfile=null;
	    setVisible(false);
        dispose();
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	
				   	
	public void finalize() {
		talk("                                                                 RamifyRawDotPic for file= "+fileName+" snuffs");
		}
		
	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

