package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class SegmenterCanvas extends Canvas implements  java.awt.event.MouseListener {
	int moustStopX=0;
	int moustStopY=0;
	int mouseStartX = 0;
	int mouseStartY = 0;
	Segmenter parent=null;
	Color bblue = new Color(0,  0 , 255);
	int width=1000,height=180;
	int slater=128, slateg=140, slateb=160;
	
	public SegmenterCanvas(Segmenter parent){
		int i;
		this.parent=parent;
		moustStopX=0; moustStopY=0;
		setBackground(new Color(slater, slateg, slateb));
		addMouseListener(this);
   		}
   	
   
	public void update(Graphics2D g) {
		paint(g);
		}
	
	public void mouseClicked(java.awt.event.MouseEvent event) {
		// talk("Mouse Clicked at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mousePressed(java.awt.event.MouseEvent event) {
		    mouseStartX = event.getX();
		    mouseStartY = event.getY();
			// talk("Mouse Pressed at "+mouseStartX+", "+mouseStartX);		    
		}
		
		
	public void mouseEntered(java.awt.event.MouseEvent event) {
		// talk("Mouse entered at ("+event.getX()+", "+event.getY()+")");
		}
		
	public void mouseExited(java.awt.event.MouseEvent event) {
		//parent.unRegisterLastClickedPic(20);
		}
		
	public void mouseReleased(java.awt.event.MouseEvent event) {	
		moustStopX = event.getX();
		moustStopY = event.getY();
		// talk("Mouse released at "+moustStopX+", "+moustStopY);
		if(parent.linkTwoNodesQ(mouseStartX, mouseStartY, moustStopX, moustStopY))
			repaint();
		}

	public void paint(Graphics g) {
		//talk("This should never happen. SegmenterCanvas.paint() called");
		paint2D((Graphics2D)g);
		}
		
	public void update(Graphics g) {
		// talk("SegmenterCanvas.update() called. Should never happen");
		paint2D((Graphics2D)g);
		}

	public void update2D(Graphics2D g) {
		paint2D(g);
		}

	public void paint2Dwww(Graphics2D g,  boolean ifVirgin) {
	    //justFinished=ifVirgin;
	    talk("virgin paint");
	    repaint();
	    }
	    
	public void paint2D(Graphics2D g) {
		GraphicsPs gg = new GraphicsPs(parent.width,parent.height,g,
			parent.ifWritePostscriptFile);
		parent.ifWritePostscriptFile = false;
		gg.newColor(slater, slateg, slateb);
		parent.setFillHeight();
		if(width != parent.width || height != parent.fillHeight) {
			width = parent.width;
			height = parent.fillHeight;
			setSize(width,height);
			}
		g.fillRect(0,0,parent.width,parent.fillHeight);
		parent.drawNodes(gg);
		parent.ifWritePostscriptFile = false;
		gg.finish();
		parent.displayParJPanels();
		// requestFocus();
		}
	
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}  
