package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class SlideWholeStack extends JFrame  implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel=null;
	int nomwidth=190,nomheight=80;
	
    public SlideWholeStack(ShowPicJPanel picJPanel) {   
    super("Slide Whole stack");
	this.picJPanel = picJPanel;
    getContentPane().setLayout(new BorderLayout()); 
    setSize(nomwidth, nomheight);
	setBackground(Color.lightGray);
	JPanel slidePan;
	WidgetMaker wmk = new WidgetMaker(this);
	slidePan = new JPanel();
	slidePan.setLayout(new GridLayout(0, 3));
	slidePan.add(wmk.makeAJButton("up"));
	slidePan.add(wmk.makeAJButton("<--"));
	slidePan.add(wmk.makeAJButton("++Z"));
	slidePan.add(wmk.makeAJButton("down"));
	slidePan.add(wmk.makeAJButton("-->"));
	slidePan.add(wmk.makeAJButton("--Z"));
	slidePan.add(wmk.makeAJButton("reds = 0",wmk.lightred));
	slidePan.add(wmk.makeAJButton("greens=0",wmk.lightgreen));
	slidePan.add(wmk.makeAJButton("blues =0",wmk.lightblue));
	getContentPane().add("Center",slidePan);
	addWindowListener(this);
  }
		
// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	 
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
    	if(arg.equals("-->")) {picJPanel.allShift(1,0,0);}
		if(arg.equals("<--")) {picJPanel.allShift(-1,0,0);}
		if(arg.equals("up")) {picJPanel.allShift(0,-1,0);}
		if(arg.equals("down")) {picJPanel.allShift(0,1,0);}
		if(arg.equals("++Z")) {picJPanel.allShift(0,0,1);}
		if(arg.equals("--Z")) {picJPanel.allShift(0,0,-1);}
		if(arg.equals("reds = 0")) {picJPanel.noShift(0);}
		if(arg.equals("greens=0")) {picJPanel.noShift(1);}
		if(arg.equals("blues =0")) {picJPanel.noShift(2);}
    }

	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

