package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;
import java.util.*;
import java.io.*;
import java.net.*;

/* transaction by which server reads a byte array from a client:
first 5 bytes in are the int READFILEARRAY=6
next fve bytes are the int = fileLength giving the number of bytes in the file array
next 5 bytes in are the int =nameBytes, giving the length of the byte array containing the file name
next nameBytes bytes in supply the file name
next fileLength bytes are the contents of the file. 

after successful file writing, the server sends the int READFILEARRAY back
 */
 
 
   
/* transaction by which a client tells this server to terminate all FileTransactors
currently active except for t his one (the one that gets this command)
first 5 bytes in are the int STOPALLTRANSACTORS_RESTART
we then stop them all, and send back the int STOPALLTRANSACTORS_RESTART
*/


public class WebFileClient {
	int ncols=1,nrows=1,nsects=1;
	int nxycols,nxyrows,nxypix,nxzcols,nxzrows,nxzpix,nzycols,
			nzyrows,nzypix;
	DataInputStream in,prein;
	DataOutputStream out,preout;
	final static int GEOFXCEPT=-2;
	final static int GIOEXCEPT=-1;
	final static int READFILEARRAY=6;
	final static int STOPALLTRANSACTORS_RESTART=7;
	final static int GTERMINATE = 10;
	Socket s=null;
	String goodIP=null;

	int portNum=-1;
	boolean ifOnLine=false;
	Thread lookAhead=null;
	int ifRGB=0;
	String chanName=" red ";
	
	// use the run thread to get what is likely to be "the next" section 
	int readyXYsectNum=-1,readyXZsectNum=-1,readyZYsectNum=-1;
	int jumpXYsectNum=-1,jumpXZsectNum=-1,jumpZYsectNum=-1;
	int justGotXYsect=-1,justGotXZsect=-1,justGotZYsect=-1;
	byte [] readyXYsect,readyXZsect,readyZYsect;
	byte [] jumpXYsect,jumpXZsect,jumpZYsect;
	
	SectionNavigator jumper;
	int cacheLevel=-777,previousCacheLevel=2;
			
	public WebFileClient(String hostname) throws Exception {
	int theFilePort=7600;
	portNum = theFilePort;
	InetAddress address;
	if(hostname != null) { // A hostname must be supplied. We try to get its IP number
	  try {
		address = InetAddress.getByName(hostname);
		talk("getByName returns <"+address+">");
		s = new Socket(address,portNum);
		makeInAndOut(); // hoses other server sockets
		ifOnLine=true;
		}
	  catch (Exception e) {
		talk(" InetAddress.getByName("+hostname+") threw "+e);
		}
	
	  if(!ifOnLine) {	
		try {
			s = new Socket(hostname,portNum);
			makeInAndOut(); // hoses other server sockets               
			ifOnLine=true;
			}
		catch (Exception e) {
			talk(chanName+"client attempt to create socket threw "+e);
			}
		}
		}
		
		else talk("Failed to open a webFileServer  socket");
		
	}
	
public void sepuku() {
	if (s != null) {
		try{in.close();
		out.close();
		s.close();}
		catch(Exception e) {}
		}
	}
	
	private void sleeper(int howLong) {
		try{Thread.sleep(howLong);}
		catch(InterruptedException e) {}
		}	
		
	private void makeInAndOut() {
		try {
			out = new DataOutputStream(s.getOutputStream());
			out.flush();
			}
		catch(Exception e) {
			talk("making out threw this exception "+e);
			}
		try{		
			in = new DataInputStream(s.getInputStream());
			}
		catch(Exception e) {
			talk("making in threw this exception "+e);
			}					
		//talk("try to terminateAllTransactorssButThis() ");
		try {out.write(encodeIntAs5Bytes(STOPALLTRANSACTORS_RESTART));}
		catch(IOException e) {
			talk(chanName+"channel oops: got ioException writing an int");
			}
		if(readAnInt() == STOPALLTRANSACTORS_RESTART)
			talk("terminateAllTransactorssButThis() worked");
		else talk("terminateAllTransactorssButThis()  failed");
		}
				
				
	private byte [] encodeIntAs5Bytes(int theInt) {
		byte [] byts = new byte[5];
		int rem,quot;
		if(theInt>=0) {
			byts[0] = (byte)(1); // first byte encodes the sign
			}
		else {
			byts[0]=(byte) (-1);
			theInt = -theInt;
			}
		for(int i=0;i<4;i++) {
			quot = theInt/256;
			rem = theInt - 256*quot;
			theInt=quot;
			if(rem>127) rem = rem-256;
			byts[4-i]=(byte)(rem);
			}
		return byts;	
		}
		
	private int decodeIntFrom5Bytes(byte [] the5Bytes) {
		int ibyte,theInt,i;
		theInt=0;
		for(i=0;i<4;i++) {
			if((ibyte=the5Bytes[i+1]) <0)
				ibyte+=256;
			theInt = 256*theInt + ibyte;
			}
		if(the5Bytes[0]<0)
			return (-theInt);
		else return (theInt);	
		}
		
	private void  writeAnInt(int theInt) {
		try {out.write(encodeIntAs5Bytes(theInt));}
		catch(IOException e) {
			talk(chanName+"channel oops: got ioException writing an int");
			}
		}
		
	private int bytesAvailable() {
		int avail=0;
		try {avail=in.available();}
		catch(IOException e) {};
		return avail;
		}
				
	private void waitForEnoughBytes(int howManyBytes) {
		while(bytesAvailable() < howManyBytes) {
			try {(Thread.currentThread()).sleep(20);}
			catch (InterruptedException e) {} 
			}			
		}
			
	private int readAnInt() {
		byte [] in5 = new byte[5];
		int inread=0;
		waitForEnoughBytes(5);
		try {inread=in.read(in5);}
		catch (EOFException e) {return -2;}
		catch (IOException e) {return -1;}
		if(inread != 5) {
			talk(chanName+"channel oops: did not get 5 bytes when reading an int");
			return 0;
			}
		return (decodeIntFrom5Bytes(in5));
		}
		
			
	public void sendFileToServer(String fileName, int [] theInts, int nints) {
		// convert an int array to a byte[] array, sending the 3 lowest order bytes of each int
		int nbytes = 3*nints;
		int redmask,greenmask,bluemask;
		int red,green,blue,rgb;
		byte [] theBytes = new byte[nbytes];
		int i=0,j;
		for(j=0;j<nints;j++) {
			rgb=theInts[j];
			blue = rgb & 255;
			green = (rgb>>8) & 255;
			red = (rgb>>16) & 255;
			theBytes[i] = (byte)red;
			++i;
			theBytes[i] = (byte)green;
			++i;
			theBytes[i] = (byte)blue;
			++i;
			} // that fills up the theBytes array with the color values
		
		 sendFileToServer(fileName, theBytes, nbytes);
		 }
		
	public void sendFileToServer(String fileName, byte [] theBytes, int nbytes) {
/* transaction by which server reads a byte array from a client:
first 5 bytes in are the int READFILEARRAY=6
next fve bytes are the int = fileLength giving the number of bytes in the file array
next 5 bytes in are the int =nameBytes, giving the length of the byte array containing the file name
next nameBytes bytes in supply the file name
next fileLength bytes are the contents of the file. 

after successful file writing, the server sends the int READFILEARRAY back
 */ 
		writeAnInt(READFILEARRAY);
		writeAnInt(nbytes);
		int nameLength = fileName.length();
 		byte [] bytesOfName = new byte[nameLength];
 		fileName.getBytes(0,nameLength,bytesOfName,0);
		writeAnInt(nameLength);
		try{ 
			out.write(bytesOfName,0,nameLength);
 			}
 		catch(IOException e) {
 			talk(chanName+"channel OOPS; sendRasterToServer failed");
 			return;
 			}
		int nout = 0;
		int nchunk = 265*256;
		while(nout < nbytes) {
			if(nchunk > nbytes-nout)
				nchunk = nbytes-nout;
			try{ 
				out.write(theBytes,nout,nchunk);
				nout += nchunk;
 				}
 			catch(IOException e) {
 				talk(chanName+"channel OOPS; sendRasterToServer failed");
 				return;
 				}
 			}
 		if(readAnInt() != READFILEARRAY)
 			talk("Something is wrong with the webFileServer");
		}
		
	static void talk(String p) {
		System.out.println(p);
	}	

}
