package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;

class showDeconJFrame extends JFrame implements java.awt.event.ActionListener{
	showDeconCanvas canvas=null;
	Deconvolver parent;
	int	mouseStartX, mouseStartY; 	// Used when dragging center of postage stamp region around
	int sectionNumber;
	JTextField Xtext,Ytext;
	JButton Ztext;
	JTextField [] brights = new JTextField[6];
	int myWidth=10;
	int myHeight=10;
	
public void sepuku() {
	if(canvas != null)
		canvas.sepuku();
	canvas=null;
	parent=null;
	setVisible(false);
	//  talk("++++++++++BestSegJFrame.sepuku()");
	dispose();
	}	
	
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
		canvas.ifPaintHistogram = !canvas.ifPaintHistogram;
		canvas.repaint();
		}



public void pixelReport(int x, int y, int [] bri,int [] avg) {
	Xtext.setText(" X = "+x);
	Ytext.setText(" Y = "+y);
	Ztext.setText("section "+sectionNumber);
	brights[0].setText("pt= ("+bri[0]+",");
	brights[1].setText("   "+bri[1]+",");
	brights[2].setText(""+bri[2]+") RGB");
	brights[3].setText("avg=("+avg[0]+",");
	brights[4].setText("   "+avg[1]+",");
	brights[5].setText(""+avg[2]+") RGB");
	}

	public boolean confirmSize(int theWidth, int theHeight) {
		if(myWidth != theWidth || myHeight != theHeight)
			return false;
		else 
			return true;
		}
	
	public showDeconJFrame(int ncols, int nrows, int secnum, Deconvolver parent) {	
		super("current deconvolution of section "+secnum);				
		this.parent=parent;
		setBackground(Color.white);
		getContentPane().setLayout(new BorderLayout());
		canvas = new showDeconCanvas(ncols,  nrows, this);
		setSize(ncols,nrows+20);
		myWidth = ncols;
		myHeight = nrows;
		this.sectionNumber = secnum;
		WidgetMaker wmk = new WidgetMaker(this);
		Xtext = wmk.makeAJTextField((""+0),12,Color.yellow);
		Ytext = wmk.makeAJTextField((""+0),12,Color.yellow);
		Ztext = wmk.makeAJButton((""+0),Color.yellow);
		Ztext.setText("section "+sectionNumber);
		JPanel pixReport = new JPanel();
		pixReport.setLayout(new GridLayout(1,9));
		pixReport.add(Ztext);
		pixReport.add(Xtext);
		pixReport.add(Ytext);
		for(int i=0;i<6;i++) {
			brights[i] = wmk.makeAJTextField((""+0),10,Color.yellow);
			pixReport.add(brights[i]);
			}
		getContentPane().add("Center",canvas);
		getContentPane().add("North",pixReport);
		setVisible(true);
		repaint();
		}
				
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
		  		
	public int newPic(int secnum, byte [] theDeconRaster, int deconSectionColor,
				byte [] origRas, int origSectColor) {
		setTitle("current deconvolution of section "+secnum);				
		setVisible(true);
		this.sectionNumber = secnum;
		Ztext.setText("section "+sectionNumber);
		return(canvas.newPic(theDeconRaster, deconSectionColor,origRas, origSectColor));
		}
	
	public void paint(Graphics g) {
		//talk("This should never happen. showDeconJFrame.paint() called");
		paint2D((Graphics2D)g);
		}
		
	public void update(Graphics g) {
		// talk("showDeconJFrame.update() called. Should never happen");
		paint2D((Graphics2D)g);
		}

	public void update2D(Graphics2D g) {
		paint2D(g);
		}

	public void paint2D(Graphics2D g) {
		canvas.paint2D(g);
		}
		
		
}
